
package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.RegistrasiPelayananPasienService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.PemeriksaanSelanjutnyaVO;
import com.jasamedika.medifirst2000.vo.RegPelayananPasienVO;

/**
 * Controller class for Registrasi Pasien Business
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/registrasi-pelayanan-pasien")
public class RegistrasiPelayananPasienController extends LocaleController<PemeriksaanSelanjutnyaVO> implements IBaseRestController<PemeriksaanSelanjutnyaVO> {

	
	
	@Autowired
	private RegistrasiPelayananPasienService registrasiPelayananPasienService;
	
	private static final Logger LOGGER = LoggerFactory.getLogger(RegistrasiPelayananPasienController.class);	
	

	@RequestMapping(value = "/save-pemeriksaan-selanjutnya", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> saveRegistrasiPelayananPasien(@Valid @RequestBody RegPelayananPasienVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = registrasiPelayananPasienService.createRegistrasiPelayananPasien(vo.getNoRegistrasi(), null);

			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}
	
	@RequestMapping(value = "/update-pemeriksaan-selanjutnya", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> updateRegistrasiPelayananPasien(@Valid @RequestBody PemeriksaanSelanjutnyaVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = registrasiPelayananPasienService.updateRegistrasiPelayananPasien(vo);

			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}


	@Override
	public ResponseEntity<PemeriksaanSelanjutnyaVO> getVO(Integer id) {
		return null;
	}


	@Override
	public ResponseEntity<String> addVO(PemeriksaanSelanjutnyaVO vo) {
		return null;
	}


	@Override
	public ResponseEntity<String> editVO(PemeriksaanSelanjutnyaVO vo) {
		return null;
	}


	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}


	@Override
	public ResponseEntity<List<PemeriksaanSelanjutnyaVO>> getAllVO() {
		return null;
	}




	@Override
	public ResponseEntity<Collection<PemeriksaanSelanjutnyaVO>> getAllVOWithQueryString(HttpServletRequest request,Integer page, Integer limit, String sort, String dir) {
		return null;
	}
	


}
